package br.usp.ime.mac0321.aula08;

public class FabricaConcreta1 implements FabricaAbstrata {

    @Override
    public ProdutoAbstratoA createProdutoA() {
        return new ProdutoA1();
    }
    @Override
    public ProdutoAbstratoB createProdutoB() {
        return new ProdutoB1();
    }
}

class ProdutoA1 implements ProdutoAbstratoA {

}

/*
 * Nota: Object.getClass() devolve um objeto da classe java.lang.Class<T>.
 * Já usamos implicitamente objetos desta classe no primeiro atributo de assertThrows:
 *    assertThrows(Exception.class, () -> {método})
 * A classe Class possui um método String getName()
 */

class ProdutoB1 implements ProdutoAbstratoB {

    @Override
    public void interagir(ProdutoAbstratoA a) {
        System.out.println(this.getClass().getName() + " interage1 com a maravilha do " + 
        						a.getClass().getName());
        //System.out.flush();
    }

}

